﻿using System;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace winforms
{
    public partial class Form1 : Form
    {
        private CExchangeData InOutTodll;

        public Form1(CExchangeData dataptr)
        {
            InOutTodll = dataptr;
            InOutTodll.Form1Runing = false;
            InitializeComponent();
            InOutTodll.Form1Runing = true;
            this.TopMost = true;
        }

        public void InitLabel()
        {
            label1.Text = InOutTodll.Bid.ToString(InOutTodll.DigitFormat);
            label2.Text = InOutTodll.Ask.ToString(InOutTodll.DigitFormat);
            label3.Text = InOutTodll.Spread.ToString();
            numericUpDown1.DecimalPlaces = numericUpDown2.DecimalPlaces = numericUpDown3.DecimalPlaces  = Convert.ToInt32(InOutTodll.Digits);
            numericUpDown1.Increment     = numericUpDown2.Increment     = numericUpDown3.Increment      = Convert.ToDecimal(InOutTodll.Point);
            numericUpDown1.Value         = numericUpDown2.Value         = numericUpDown3.Value          = Convert.ToDecimal(InOutTodll.Bid);
        }

        public void RefreshComponent()
        {
            label1.Text = InOutTodll.Bid.ToString(InOutTodll.DigitFormat);
            label2.Text = InOutTodll.Ask.ToString(InOutTodll.DigitFormat);
            label3.Text = InOutTodll.Spread.ToString();
            label4.Text = "Balance: " + InOutTodll.Balance.ToString("0.00");
            label5.Text = "Equity: "  + InOutTodll.Equity.ToString("0.00");
            label6.Text = "Margin: "  + InOutTodll.Margin.ToString("0.00");
        }

        public void StateCheckboxForm1()
        {
            InOutTodll.m_checkbox[0] = 1;
            InOutTodll.m_checkbox[1] = checkBox1.Checked ? 1 : 0;
            InOutTodll.m_checkbox[2] = checkBox2.Checked ? 1 : 0;
            InOutTodll.m_checkbox[3] = checkBox3.Checked ? 1 : 0;
            InOutTodll.m_checkbox[4] = checkBox4.Checked ? 1 : 0;
            InOutTodll.m_checkbox[5] = checkBox5.Checked ? 1 : 0;
        }

        private void ButtonClick(object sender, EventArgs e)
        {
            InOutTodll.ClickButton = Convert.ToInt32(((RoundButton)sender).Tag);
        }

        private void checkBox_Click(object sender, EventArgs e)
        {
            int tag = Convert.ToInt32(((CheckBox)sender).Tag);
            switch(tag)
            {
                case 1: checkBox1.Checked = true;   checkBox2.Checked = checkBox3.Checked = false;
                break;
                case 2:
                        checkBox2.Checked = true;   checkBox1.Checked = checkBox3.Checked = false;
                break;
                case 3:
                        checkBox3.Checked = true;   checkBox1.Checked = checkBox2.Checked = false;
                break;
            }
            StateCheckboxForm1();
        }

        private void checkBox5_CheckedChanged(object sender, EventArgs e)
        {
            StateCheckboxForm1();
            if(checkBox5.Checked)
            {
                numericUpDown4.Visible = numericUpDown5.Visible = true;
                numericUpDown4.Enabled = numericUpDown5.Enabled = true;
                numericUpDown2.Visible = numericUpDown3.Visible = false;
                numericUpDown2.Enabled = numericUpDown3.Enabled = false;
            }
            else
            {
                numericUpDown4.Visible = numericUpDown5.Visible = false;
                numericUpDown4.Enabled = numericUpDown5.Enabled = false;
                numericUpDown2.Visible = numericUpDown3.Visible = true;
                numericUpDown2.Enabled = numericUpDown3.Enabled = true;
            }
        }

        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {
            StateCheckboxForm1();
        }

        private void label2_DoubleClick(object sender, EventArgs e)
        {
            numericUpDown1.Value = numericUpDown2.Value = numericUpDown3.Value = Convert.ToDecimal(InOutTodll.Ask);
            EditBoxChanged();
        }

        private void label1_DoubleClick(object sender, EventArgs e)
        {
            numericUpDown1.Value = numericUpDown2.Value = numericUpDown3.Value = Convert.ToDecimal(InOutTodll.Bid);
            EditBoxChanged();
        }

        private void EditBoxChanged()
        {
            InOutTodll.EditLot              = Convert.ToDouble(numericUpDown0.Value);
            InOutTodll.EditPrice            = Convert.ToDouble(numericUpDown1.Value);
            InOutTodll.EditDoubleTakeprofit = Convert.ToDouble(numericUpDown2.Value);
            InOutTodll.EditDoubleStoploss   = Convert.ToDouble(numericUpDown3.Value);
            InOutTodll.EditIntTakeProfit    = Convert.ToInt32(numericUpDown4.Value);
            InOutTodll.EditIntStopLoss  = Convert.ToInt32(numericUpDown5.Value);
        }

        private void numericUpDownValueChanged(object sender, EventArgs e)
        {
            EditBoxChanged();
        }

        private void checkBox4_CheckedChanged_1(object sender, EventArgs e)
        {
            InOutTodll.Form2Visible = checkBox4.Checked;
            StateCheckboxForm1();
        }
    }

    public class RoundButton : Control
    {
        public Color BackColor2 { get; set; }
        public Color ButtonBorderColor { get; set; }
        public int ButtonRoundRadius { get; set; }
        public Color ButtonHighlightColor { get; set; }
        public Color ButtonHighlightColor2 { get; set; }
        public Color ButtonHighlightForeColor { get; set; }
        public Color ButtonPressedColor { get; set; }
        public Color ButtonPressedColor2 { get; set; }
        public Color ButtonPressedForeColor { get; set; }
        private bool IsHighlighted;
        private bool IsPressed;

        public RoundButton()
        {
            Size = new Size(100, 40);
            ButtonRoundRadius = 30;
            BackColor = Color.Gainsboro;
            BackColor2 = Color.Silver;
            ButtonBorderColor = Color.Black;
            ButtonHighlightColor = Color.Silver;
            ButtonHighlightColor2 = Color.Silver;
            ButtonHighlightForeColor = Color.Black;
            ButtonPressedColor = Color.Red;
            ButtonPressedColor2 = Color.Maroon;
            ButtonPressedForeColor = Color.White;
        }

        protected override CreateParams CreateParams
        {
            get
            {
                CreateParams createParams = base.CreateParams;
                createParams.ExStyle |= 0x00000020; // WS_EX_TRANSPARENT
                return createParams;
            }
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            e.Graphics.SmoothingMode = SmoothingMode.HighQuality;
            var foreColor = IsPressed ? ButtonPressedForeColor : IsHighlighted ? ButtonHighlightForeColor : ForeColor;
            var backColor = IsPressed ? ButtonPressedColor : IsHighlighted ? ButtonHighlightColor : BackColor;
            var backColor2 = IsPressed ? ButtonPressedColor2 : IsHighlighted ? ButtonHighlightColor2 : BackColor2;
            using (var pen = new Pen(ButtonBorderColor, 1))
                e.Graphics.DrawPath(pen, Path);
            using (var brush = new LinearGradientBrush(ClientRectangle, backColor, backColor2, LinearGradientMode.Vertical))
                e.Graphics.FillPath(brush, Path);
            using (var brush = new SolidBrush(foreColor))
            {
                var sf = new StringFormat { Alignment = StringAlignment.Center, LineAlignment = StringAlignment.Center };
                var rect = ClientRectangle;
                rect.Inflate(-4, -4);
                e.Graphics.DrawString(Text, Font, brush, rect, sf);
            }
            base.OnPaint(e);
        }
        protected override void OnPaintBackground(PaintEventArgs e)
        {
        }
        protected override void OnMouseEnter(EventArgs e)
        {
            base.OnMouseEnter(e);
            IsHighlighted = true;
            Parent.Invalidate(Bounds, false);
            Invalidate();
        }
        protected override void OnMouseLeave(EventArgs e)
        {
            base.OnMouseLeave(e);
            IsHighlighted = false;
            IsPressed = false;
            Parent.Invalidate(Bounds, false);
            Invalidate();
        }
        protected override void OnMouseDown(MouseEventArgs e)
        {
            base.OnMouseDown(e);
            Parent.Invalidate(Bounds, false);
            Invalidate();
            IsPressed = true;
        }
        protected override void OnMouseUp(MouseEventArgs e)
        {
            base.OnMouseUp(e);
            Parent.Invalidate(Bounds, false);
            Invalidate();
            IsPressed = false;
        }
        protected GraphicsPath Path
        {
            get
            {
                var rect = ClientRectangle;
                rect.Inflate(-1, -1);
                return GetRoundedRectangle(rect, ButtonRoundRadius);
            }
        }
        public static GraphicsPath GetRoundedRectangle(Rectangle rect, int d)
        {
            var gp = new GraphicsPath();
            gp.AddArc(rect.X, rect.Y, d, d, 180, 90);
            gp.AddArc(rect.X + rect.Width - d, rect.Y, d, d, 270, 90);
            gp.AddArc(rect.X + rect.Width - d, rect.Y + rect.Height - d, d, d, 0, 90);
            gp.AddArc(rect.X, rect.Y + rect.Height - d, d, d, 90, 90);
            gp.CloseFigure();
            return gp;
        }
    }
}
