﻿using System;
using System.Windows.Forms;

namespace winforms
{
    public partial class Form2 : Form
    {
        private CExchangeData InOutTodll;
        private string[] optype = new string[7] { " buy", " sell", " buy limit", " sell limit", " buy stop", " sell stop"," Balance" };

        public Form2(CExchangeData dataptr)
        {
            InOutTodll = dataptr;
            InOutTodll.Form2Runing = false;
            InitializeComponent();
            InOutTodll.Form2Runing = true;
            this.TopMost = true;
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            this.ControlBox = false;
            Table.ColumnsCount = 11;
            Table.FixedRows = 1;
            Table.Rows.Insert(0);
            Table[0, 0] = new SourceGrid.Cells.ColumnHeader("Symbol");
            Table[0, 1] = new SourceGrid.Cells.ColumnHeader("Ticket");
            Table[0, 2] = new SourceGrid.Cells.ColumnHeader("Time");
            Table[0, 3] = new SourceGrid.Cells.ColumnHeader("Type");
            Table[0, 4] = new SourceGrid.Cells.ColumnHeader("Volume");
            Table[0, 5] = new SourceGrid.Cells.ColumnHeader("Price");
            Table[0, 6] = new SourceGrid.Cells.ColumnHeader("Stoploss");
            Table[0, 7] = new SourceGrid.Cells.ColumnHeader("Takeprofit");
            Table[0, 8] = new SourceGrid.Cells.ColumnHeader("Swap");
            Table[0, 9] = new SourceGrid.Cells.ColumnHeader("Profit");
            Table[0, 10] = new SourceGrid.Cells.ColumnHeader("Comment");
            Table.EnableSort = false;
        }

        public void AddRow(int pos = -1, string symbol="", int ticket=0,       string time="",        int type=0,   double volume=0.0, 
                           double prices=0.0, double stoploss=0.0,  double takeprofit=0.0,  double swap=0.0, double profit=0.0, string comment="")
        {
            int i,count ;
            if (pos < 0)
            {
                count = Table.RowsCount;
                Table.Rows.Insert(count);
                Table[count, 0] = new SourceGrid.Cells.Cell(symbol, typeof(string));
                Table[count, 1] = new SourceGrid.Cells.Cell(ticket, typeof(int));
                Table[count, 2] = new SourceGrid.Cells.Cell(time, typeof(string));
                Table.Columns[2].Width = 130;
                Table[count, 3] = new SourceGrid.Cells.Cell(optype[type], typeof(string));
                Table[count, 4] = new SourceGrid.Cells.Cell(volume.ToString(), typeof(string));
                Table[count, 5] = new SourceGrid.Cells.Cell(prices.ToString(), typeof(string));
                Table[count, 6] = new SourceGrid.Cells.Cell(stoploss.ToString(), typeof(string));
                Table[count, 7] = new SourceGrid.Cells.Cell(takeprofit.ToString(), typeof(string));
                Table[count, 8] = new SourceGrid.Cells.Cell(swap.ToString(), typeof(string));
                Table[count, 9] = new SourceGrid.Cells.Cell(profit.ToString(), typeof(string));
                Table[count, 10] = new SourceGrid.Cells.Cell(comment, typeof(string));
                for (i = 0; i < 11; i++)
                {
                    Table[count, i].Editor.EditableMode = SourceGrid.EditableMode.None;
                }
            }
            else
            {
                count = pos;
                Table[count,0].Value = symbol;
                Table[count, 1].Value = ticket;
                Table[count, 2].Value = time;
                Table[count, 3].Value = optype[type];
                Table[count, 4].Value = volume.ToString("0.00");
                Table[count, 5].Value = prices.ToString(InOutTodll.DigitFormat);
                Table[count, 6].Value = stoploss.ToString(InOutTodll.DigitFormat);
                Table[count, 7].Value = takeprofit.ToString(InOutTodll.DigitFormat);
                Table[count, 8].Value = swap.ToString("0.00");
                Table[count, 9].Value = profit.ToString("0.00");
                Table[count, 10].Value = comment;
            }
        }

        private void closeOrderToolStripMenuItem_Click(object sender, EventArgs e)
        {
            InOutTodll.ClickButton = 9;
        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            InOutTodll.ClickButton = 10;
            InOutTodll.ContexMenuTrailing = Convert.ToInt32(((ToolStripMenuItem)sender).Tag);
        }

        private void Table_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                int pos_row = Table.MouseCellPosition.Row;
                if (pos_row > 0)
                {
                    Table.Selection.FocusRow(Table.MouseCellPosition.Row);
                    InOutTodll.ContexMenuTicket = Convert.ToInt32(Table[pos_row, 1].Value);
                    contextMenuStrip1.Enabled = true;
                }
                else
                {
                    Table.Selection.ResetSelection(false);
                    InOutTodll.ContexMenuTicket = -1;
                    contextMenuStrip1.Enabled = false;
                }
            }
        }

        private void contextMenuStrip1_Opened(object sender, EventArgs e)
        {
            int pos_row = Table.MouseCellPosition.Row;
            if (pos_row > 0)
            {
                Table.Selection.FocusRow(Table.MouseCellPosition.Row);
                InOutTodll.ContexMenuTicket = Convert.ToInt32(Table[pos_row, 1].Value);
                contextMenuStrip1.Enabled = true;
            }
            else
            {
                Table.Selection.ResetSelection(false);
                InOutTodll.ContexMenuTicket = -1;
                contextMenuStrip1.Enabled = false;
            }
        }
    }
}
