﻿using System;
using System.Threading;
using System.Runtime.InteropServices;
using RGiesecke.DllExport;


namespace winforms
{
    public class CExchangeData
    {
        const int NUM_BUTTON = 10;           // Кол-во кнопок в форме
        const int NUM_CHECKBOX = 5;         // Кол-во чекбоксов в форме
        public double Ask, Bid, Point, Balance, Equity, Margin, EditLot, EditPrice, EditDoubleTakeprofit, EditDoubleStoploss;
        public int Digits, Spread, EditIntTakeProfit, EditIntStopLoss, ContexMenuTrailing, ContexMenuTicket;
        public string DigitFormat;
        public int[] m_checkbox, m_button;
        public Form2 Form_2;
        private bool runform1, runform2;

        public CExchangeData()
        {
            m_button = new int[NUM_BUTTON + 1];
            m_checkbox = new int[NUM_CHECKBOX + 1];
            Array.Clear(m_button, 0, m_button.Length);
            Array.Clear(m_checkbox, 0, m_checkbox.Length);
            ContexMenuTicket = -1;
        }

        public bool Form1Runing
        {
            get => runform1;
            set => runform1 = value;
        }

        public bool Form2Runing
        {
            get => runform2;
            set => runform2 = value;
        }

        public int ClickButton
        {
            set
            {
                m_button[value]++;
                m_button[0] = m_button[0] == 0 ? value : -1;
            }
        }

        public bool Form2Visible
        {
            get => Form_2.Visible;
            set => Form_2.Visible = value;
        }
    }
    
    public static class FormsMT4
    {
        private static Form1 MainForm;
        private static Form2 OrderForm;
        private static Thread ThreadMainform, ThreadOrderForm;
        private static CExchangeData InOutTodll;

        [DllExport("CreateForms", CallingConvention = CallingConvention.StdCall)]
        private static void CreateForms([In, Out, MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 1)] double[] d_inout, int lend,
                                        [In, Out, MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 1)] int[] i_inout, int leni)
        {
            if (InOutTodll == null) InOutTodll = new CExchangeData();
            if (OrderForm == null)
            {
                InOutTodll.Form2Runing = false;
                ThreadOrderForm = new Thread(NewOrderForm);
                ThreadOrderForm.Start();
            }
            if (MainForm == null)
            {
                InOutTodll.Form1Runing = false;
                ThreadMainform = new Thread(NewMainForm);
                ThreadMainform.Start();
            }
            InOutTodll.Ask      = d_inout[0];
            InOutTodll.Bid      = d_inout[1];
            InOutTodll.Balance  = d_inout[2];
            InOutTodll.Equity   = d_inout[3];
            InOutTodll.Margin   = d_inout[4];
            InOutTodll.Point    = d_inout[5];
            InOutTodll.Spread   = i_inout[0];
            InOutTodll.Digits   = i_inout[1];
        }

        [DllExport("FormRun", CallingConvention = CallingConvention.StdCall)]
        private static bool FormRun(ref int button, ref int checkbox)
        {
            if (MainForm == null) return false;
            if (OrderForm == null) return false;
            if (!InOutTodll.Form1Runing) return false;
            if (!InOutTodll.Form2Runing) return false;
            MainForm.StateCheckboxForm1();
            InOutTodll.m_checkbox[0] = 0;
            button   = InOutTodll.m_button.Length;
            checkbox = InOutTodll.m_checkbox.Length;
            switch (InOutTodll.Digits)
            {
                case 0: InOutTodll.DigitFormat = "#"; break;
                case 1: InOutTodll.DigitFormat = "#.0"; break;
                case 2: InOutTodll.DigitFormat = "#.#0"; break;
                case 3: InOutTodll.DigitFormat = "#.##0"; break;
                case 4: InOutTodll.DigitFormat = "#.###0"; break;
                case 5: InOutTodll.DigitFormat = "#.####0"; break;
                case 6: InOutTodll.DigitFormat = "#.#####0"; break;
                case 7: InOutTodll.DigitFormat = "#.######0"; break;
                case 8: InOutTodll.DigitFormat = "#.#######0"; break;
            }
            MainForm.InitLabel();
            InOutTodll.Form_2 = OrderForm;
            OrderForm.TopMost = true;
            OrderForm.Activate();
            OrderForm.KeyPreview = true;
            MainForm.TopMost = true;
            MainForm.Activate();
            MainForm.KeyPreview = true;
            return true;
        }

        [DllExport("FormDeinit", CallingConvention = CallingConvention.StdCall)]
        private static void FormDeinit(int reason)
        {
            if (reason == 3 || reason == 5) return;
            if (MainForm != null)
            {
                MainForm.Close();
                Thread.Sleep(250);
            }
            if (OrderForm != null)
            {
                OrderForm.Close();
                Thread.Sleep(250);
            }
            if (ThreadMainform != null)  ThreadMainform.Join();
            if (ThreadOrderForm != null) ThreadOrderForm.Join();
            MainForm        = null;
            OrderForm       = null;
            ThreadMainform  = null;
            ThreadOrderForm = null;
            InOutTodll      = null;
        }

        [DllExport("StateExchange", CallingConvention = CallingConvention.StdCall)]
        private static void StateExchange([In, Out, MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 1)] int[] button_,     int lenbutton_,
                                         [In, Out, MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 1)] int[] checkbox_,   int lencheckbox_,
                                         [In, Out, MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 1)] double[] d_inout,  int lend_inout,
                                         [In, Out, MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 1)] int[] i_inout,     int lend_i_inout)
        {
            // in data
            InOutTodll.Ask      = d_inout[0];
            InOutTodll.Bid      = d_inout[1];
            InOutTodll.Spread   = i_inout[0];
            InOutTodll.Balance  = d_inout[2];
            InOutTodll.Equity   = d_inout[3];
            InOutTodll.Margin   = d_inout[4];
            // out data
            d_inout[9] = InOutTodll.EditLot;
            d_inout[8] = InOutTodll.EditPrice;
            d_inout[7] = InOutTodll.EditDoubleTakeprofit;
            d_inout[6] = InOutTodll.EditDoubleStoploss;
            i_inout[3] = InOutTodll.EditIntTakeProfit;
            i_inout[2] = InOutTodll.EditIntStopLoss;
            i_inout[4] = InOutTodll.ContexMenuTrailing;
            i_inout[5] = InOutTodll.ContexMenuTicket;

            Array.Copy(InOutTodll.m_button, button_, InOutTodll.m_button.Length);
            Array.Copy(InOutTodll.m_checkbox, checkbox_, InOutTodll.m_checkbox.Length);
            Array.Clear(InOutTodll.m_button, 0, InOutTodll.m_button.Length);
            InOutTodll.m_checkbox[0] = 0;
            MainForm.RefreshComponent();
        }
        [DllExport("StartEditOrderTable", CallingConvention = CallingConvention.StdCall)]
        private static void StartEditOrderTable(int ordercount)
        {
            InOutTodll.Form_2.Table.Enabled = false;
            int tablerowcount = InOutTodll.Form_2.Table.RowsCount-1;
            if (tablerowcount != ordercount)
            {
                while (ordercount < tablerowcount)
                {
                    InOutTodll.Form_2.Table.Rows.Remove(tablerowcount--);
                }
                while (ordercount > tablerowcount++)
                {
                    InOutTodll.Form_2.AddRow();
                }
            }
        }

        [DllExport("EditOrderTable", CallingConvention = CallingConvention.StdCall)]
        private static void EditOrderTable(int count,
                                          [MarshalAs(UnmanagedType.LPWStr)]string inSymbol, 
                                          int inTicket,
                                          [MarshalAs(UnmanagedType.LPWStr)]string inTime, 
                                          int inType, double inVolume, double inPrice, double inStoploss, double inTakeprofit, double inSwap, double inProfit,
                                          [MarshalAs(UnmanagedType.LPWStr)]string inComment)
        {
            if (count < InOutTodll.Form_2.Table.RowsCount)
                InOutTodll.Form_2.AddRow(count+1, inSymbol, inTicket,inTime,inType,inVolume,inPrice,inStoploss,inTakeprofit,inSwap,inProfit,inComment);
        }

        [DllExport("EndEditOrdertable", CallingConvention = CallingConvention.StdCall)]
        private static void EndEditOrdertable()
        {
            InOutTodll.Form_2.Table.Enabled = true;
        }

        private static void NewMainForm()  { MainForm  = new Form1(InOutTodll); MainForm.ShowDialog();  }
        private static void NewOrderForm() { OrderForm = new Form2(InOutTodll); OrderForm.ShowDialog(); }
    }
    /*
    public static class FormsMT5
    {
        private static Form1 MainForm;
        private static Form2 OrderForm;
        private static Thread ThreadMainform, ThreadOrderForm;
        private static CExchangeData InOutTodll;

        public static bool FormRun(ref int button, ref int checkbox)
        {
            if (MainForm == null) return false;
            if (OrderForm == null) return false;
            if (!InOutTodll.Form1Runing) return false;
            if (!InOutTodll.Form2Runing) return false;
            MainForm.StateCheckboxForm1();
            InOutTodll.m_checkbox[0] = 0;
            button = InOutTodll.m_button.Length;
            checkbox = InOutTodll.m_checkbox.Length;
            switch (InOutTodll.Digits)
            {
                case 0: InOutTodll.DigitFormat = "#"; break;
                case 1: InOutTodll.DigitFormat = "#.0"; break;
                case 2: InOutTodll.DigitFormat = "#.#0"; break;
                case 3: InOutTodll.DigitFormat = "#.##0"; break;
                case 4: InOutTodll.DigitFormat = "#.###0"; break;
                case 5: InOutTodll.DigitFormat = "#.####0"; break;
                case 6: InOutTodll.DigitFormat = "#.#####0"; break;
                case 7: InOutTodll.DigitFormat = "#.######0"; break;
                case 8: InOutTodll.DigitFormat = "#.#######0"; break;
            }
            MainForm.InitLabel();
            InOutTodll.Form_2 = OrderForm;
            OrderForm.TopMost = true;
            OrderForm.Activate();
            OrderForm.KeyPreview = true;
            MainForm.TopMost = true;
            MainForm.Activate();
            MainForm.KeyPreview = true;
            return true;
        }

        public static void FormDeinit(int reason)
        {
            if (reason == 3 || reason == 5) return;
            if (MainForm != null)
            {
                MainForm.Close();
                Thread.Sleep(250);
            }
            if (OrderForm != null)
            {
                OrderForm.Close();
                Thread.Sleep(250);
            }
            if (ThreadMainform != null) ThreadMainform.Join();
            if (ThreadOrderForm != null) ThreadOrderForm.Join();
            MainForm = null;
            OrderForm = null;
            ThreadMainform = null;
            ThreadOrderForm = null;
            InOutTodll = null;
        }

        public static void StateExchange(ref int[] button_, ref int[] checkbox_, ref double[] d_inout, ref int[] i_inout)
        {
            // in data
            InOutTodll.Ask = d_inout[0];
            InOutTodll.Bid = d_inout[1];
            InOutTodll.Spread = i_inout[0];
            InOutTodll.Balance = d_inout[2];
            InOutTodll.Equity = d_inout[3];
            InOutTodll.Margin = d_inout[4];
            // out data
            d_inout[9] = InOutTodll.EditLot;
            d_inout[8] = InOutTodll.EditPrice;
            d_inout[7] = InOutTodll.EditDoubleTakeprofit;
            d_inout[6] = InOutTodll.EditDoubleStoploss;
            i_inout[3] = InOutTodll.EditIntTakeProfit;
            i_inout[2] = InOutTodll.EditIntStopLoss;
            i_inout[4] = InOutTodll.ContexMenuTrailing;
            i_inout[5] = InOutTodll.ContexMenuTicket;

            Array.Copy(InOutTodll.m_button, button_, InOutTodll.m_button.Length);
            Array.Copy(InOutTodll.m_checkbox, checkbox_, InOutTodll.m_checkbox.Length);
            Array.Clear(InOutTodll.m_button, 0, InOutTodll.m_button.Length);
            InOutTodll.m_checkbox[0] = 0;
            MainForm.RefreshComponent();
        }

        public static void EditOrderTable(int ordercount, string inSymbol, ref int[] inTicket, ref string[] inTime, ref int[] inType,
                                                            ref double[] inVolume, ref double[] inPrice, ref double[] inStoploss, ref double[] inTakeprofit,
                                                            ref double[] inSwap, ref double[] inProfit, ref string[] inComment)
        {
            int i, tablerowcount = InOutTodll.Form_2.Table.RowsCount - 1;
            if (tablerowcount != ordercount)
            {
                while (ordercount < tablerowcount)
                {
                    InOutTodll.Form_2.Table.Rows.Remove(tablerowcount--);
                }
                while (ordercount > tablerowcount++)
                {
                    InOutTodll.Form_2.AddRow();
                }
                for (i = 0; i < ordercount; i++)
                {
                    InOutTodll.Form_2.AddRow(i + 1, inSymbol, inTicket[i], inTime[i], inType[i], inVolume[i], inPrice[i], inStoploss[i],
                        inTakeprofit[i], inSwap[i], inProfit[i], inComment[i]);
                }
            }
        }

        public static void CreateForms(ref double[] d_inout, ref int[] i_inout)
        {
            if (InOutTodll == null) InOutTodll = new CExchangeData();
            if (OrderForm == null)
            {
                ThreadOrderForm = new Thread(NewOrderForm);
                ThreadOrderForm.Start();
            }
            if (MainForm == null)
            {
                ThreadMainform = new Thread(NewMainForm);
                ThreadMainform.Start();
            }
            InOutTodll.Ask = d_inout[0];
            InOutTodll.Bid = d_inout[1];
            InOutTodll.Balance = d_inout[2];
            InOutTodll.Equity = d_inout[3];
            InOutTodll.Margin = d_inout[4];
            InOutTodll.Point = d_inout[5];
            InOutTodll.Spread = i_inout[0];
            InOutTodll.Digits = i_inout[1];
        }

        private static void NewMainForm() { MainForm = new Form1(InOutTodll); MainForm.ShowDialog(); }
        private static void NewOrderForm() { OrderForm = new Form2(InOutTodll); OrderForm.ShowDialog(); }
    }
    */
}